/*
 * Copyright (C) 2005 - 2006
 * Anastasios Skarlatidis
 *
 * This program developed as part of the dissertation entitled:
 * A Framework for Implementation and Visualization of Evolutionary Algorithms,
 * by Anastasios Skarlatidis.
 * Technological Educational Institute of Thessaloniki,
 * Department of Information Technology
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

package examples.wasps;

import javolution.realtime.RealtimeObject;

/**
 * @author <a href="mailto:anskarl@yahoo.com">Anastasios Skarlatidis</a>
 */
final class WaspsNest extends RealtimeObject {

    private static final Factory<WaspsNest> FACTORY = new Factory<WaspsNest>() {
        protected WaspsNest create() {
            return new WaspsNest();
        }
    };

    int numberOfWasps;
    int x;
    int y;

    public static WaspsNest create(int numberOfWasps, int x, int y){
        WaspsNest nest = FACTORY.object();
        nest.numberOfWasps = numberOfWasps;
        nest.x = x;
        nest.y = y;

        return nest;
    }

    private WaspsNest(){}

    public WaspsNest(int numberOfWasps, int x, int y){
        this.numberOfWasps = numberOfWasps;
        this.x = x;
        this.y = y;
    }

    public WaspsNest copy(){
        WaspsNest cpNest = FACTORY.object();
        cpNest.numberOfWasps = this.numberOfWasps;
        cpNest.x = this.x;
        cpNest.y = this.y;
        return cpNest;
    }
}
